//---------------------------------------------------------------------------

#ifndef SqlAdminMonitorH
#define SqlAdminMonitorH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "ADOManagerQuery.h"
#include <ADODB.hpp>
#include <DB.hpp>
#include "VirtualTrees.hpp"
#include "JvComponent.hpp"
#include "JvExControls.hpp"
#include "JvGradient.hpp"
#include "JvExExtCtrls.hpp"
#include "JvGradientHeaderPanel.hpp"
#include "JvRollOut.hpp"
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <msxmldom.hpp>
#include <XMLDoc.hpp>
#include <xmldom.hpp>
#include <XMLIntf.hpp>
#include <Graphics.hpp>
#include "TntComCtrls.hpp"
//---------------------------------------------------------------------------
struct ServerNode
{
	WideString Caption;
	int NodeType;
};
struct InfoNode
{
	TTntStringList* Captions;
	int NodeType;
};
class TUpdateThread : public TThread
{
private:
	TForm* FOwner;
	TVirtualNode *ServerNode;
protected:
	void __fastcall Execute();
public:
	__fastcall TUpdateThread(bool CreateSuspended, TForm* Owner);
};
class TServerForm : public TForm
{
__published:	// IDE-managed Components
	TADOSqlManagerQuery *ManagerQuery;
	TJvRollOut *RollOut;
	TVirtualStringTree *ServerTree;
	TTntStatusBar *StatusBar;
	TXMLDocument *ServerInfoXml;
	TJvGradientHeaderPanel *ServerHeader;
	TButton *CollapseButton;
	TPanel *Panel1;
	TJvGradientHeaderPanel *InfoHeader;
	TVirtualStringTree *InfoTree;
	TImage *Image1;
	TSplitter *PanelSplitter;
	TTeMDIChild *MDIChild;
	void __fastcall ServerTreeGetText(TBaseVirtualTree *Sender, PVirtualNode Node,
		  TColumnIndex Column, TVSTTextType TextType, WideString &CellText);
	void __fastcall ServerTreeGetImageIndex(TBaseVirtualTree *Sender,
          PVirtualNode Node, TVTImageKind Kind, TColumnIndex Column,
          bool &Ghosted, int &ImageIndex);
	void __fastcall ServerTreeFreeNode(TBaseVirtualTree *Sender,
          PVirtualNode Node);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall StatusBarDrawPanel(TStatusBar *StatusBar,
          TStatusPanel *Panel, const TRect &Rect);
	void __fastcall FormDestroy(TObject *Sender);
	void __fastcall CollapseButtonClick(TObject *Sender);
	void __fastcall InfoTreeFreeNode(TBaseVirtualTree *Sender, PVirtualNode Node);
	void __fastcall InfoTreeInitNode(TBaseVirtualTree *Sender,
          PVirtualNode ParentNode, PVirtualNode Node,
          TVirtualNodeInitStates &InitialStates);
	void __fastcall InfoTreeGetText(TBaseVirtualTree *Sender, PVirtualNode Node,
          TColumnIndex Column, TVSTTextType TextType, WideString &CellText);
	void __fastcall ServerTreeChange(TBaseVirtualTree *Sender, PVirtualNode Node);
	void __fastcall RollOutCollapse(TObject *Sender);
	void __fastcall RollOutExpand(TObject *Sender);
	void __fastcall UpdateInfo();
	void __fastcall ExpandInfo(TVirtualNode *ExpandingNode);
	void __fastcall DisplayExpandInfo(TVirtualNode* ExpandingNode);
	void __fastcall DisplayInfo();
	void __fastcall ServerTreeInitNode(TBaseVirtualTree *Sender,
          PVirtualNode ParentNode, PVirtualNode Node,
          TVirtualNodeInitStates &InitialStates);
	void __fastcall ServerTreeExpanding(TBaseVirtualTree *Sender,
          PVirtualNode Node, bool &Allowed);
	void __fastcall ServerTreeCollapsing(TBaseVirtualTree *Sender,
          PVirtualNode Node, bool &Allowed);
	void __fastcall InfoTreeMeasureItem(TBaseVirtualTree *Sender,
          TCanvas *TargetCanvas, PVirtualNode Node, int &NodeHeight);
private:	// User declarations
	/*_di_IXMLNode Server;
	_di_IXMLNode Connections;
	_di_IXMLNode Logins;
	_di_IXMLNode Databases;*/
	TCriticalSection *Lock;
	TTntStringList *XmlInfo;
	void __fastcall ServerTreeIni();
	void __fastcall InfoTreeIni();
	void __fastcall InfoTreeCheckColumn(int count);
	//TUpdateThread* UpdateThread;
public:		// User declarations
	__fastcall TServerForm(TComponent* Owner);
	void __fastcall Login();
	void __fastcall Disconnect();
};
//---------------------------------------------------------------------------
extern PACKAGE TServerForm *ServerForm;
//---------------------------------------------------------------------------
#endif
